## Ecosystem

Plugins and tools maintained by the knex team are listed under [Core](#core) while plugins and tools maintained by the community are listed in the [Community](#community) section.

#### [Core](#core)
- [`casbin-knex-adapter`](https://github.com/knex/casbin-knex-adapter) Knex adapter for [Node-Casbin](https://github.com/casbin/node-casbin).
- [`knex-schema-inspector`](https://github.com/knex/knex-schema-inspector) Utility for extracting information about the existing DB schema.
- [`knex-tablecleaner`](https://github.com/kibertoad/knex-tablecleaner) Library for deleting all rows from a given list of DB tables.

#### [Community](#community)
- [`knemm`](https://github.com/asteinarson/knemm) A CLI tool to manage SQL schema in declarative YAML files (`claims` and `states`). It allows for database dependencies between loosely coupled modules. 
- [`knex-mock-client`](https://github.com/felixmosh/knex-mock-client) A mock client which helps you write integration tests which includes DB interactions.
- [`knex-paginate`](https://github.com/felixmosh/knex-paginate) Extension of the query builder with `paginate` method that helps with pagination tasks.
- [`knex-postgis`](https://github.com/jfgodoy/knex-postgis) Extension of Knex with [PostGIS](https://postgis.net/) (geographic objects in PostgreSQL) support.
- [`knex-serverless-mysql`](https://github.com/MatissJanis/knex-serverless-mysql) Knex dialect for usage with [`serverless-mysql`](https://github.com/jeremydaly/serverless-mysql): persist database connection over multiple serverless (such as AWS Lambda) function invocations.
- [`pg-mem`](https://github.com/oguimbal/pg-mem) An in-memory emulation of PostgreSQL instance, which can be used for writing blazingly fast tests. Has [adapter for Knex](https://github.com/oguimbal/pg-mem/wiki/Libraries-adapters#-knex).
- [`sqlcommenter-knex`](https://github.com/google/sqlcommenter/tree/master/nodejs/sqlcommenter-nodejs/packages/sqlcommenter-knex) A [sqlcommenter](https://google.github.io/sqlcommenter/) plugin with [support for Knex](https://google.github.io/sqlcommenter/node/knex/) to augment SQL statements with comments that can be used later to correlate application code with SQL statements.
